<?php
// +-----------------------------------------------------------------------+
// | Files statistics - a PWG Plugin                                       |
// | Copyright (C) 2007 Ruben ARNAUD - rub@phpwebgallery.net               |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

if (!defined('PHPWG_ROOT_PATH'))
{
  die('Hacking attempt!');
}

add_event_handler('pwg_log_allowed', 'fstats_pwg_log_allowed', 9999999 /* EVENT_HANDLER_PRIORITY_LAST */, 3);

function fstats_pwg_log_allowed($do_log, $image_id, $image_type)
{
  if ($do_log)
  {
    global $page, $user;
    
    $tags_string = null;
    if (isset($page['section']) and $page['section'] == 'tags')
    {
      $tag_ids = array();
      foreach ($page['tags'] as $tag)
      {
        array_push($tag_ids, $tag['id']);
      }

      $tags_string = implode(',', $tag_ids);
    }

    // here we ask the database the current date and time, and we extract
    // {year, month, day} from the current date. We could do this during the
    // insert query with a CURDATE(), CURTIME(), DATE_FORMAT(CURDATE(), '%Y')
    // ... but I (plg) think it would cost more than a double query and a PHP
    // extraction.
    $query = '
  SELECT CURDATE(), CURTIME()
  ;';
    list($curdate, $curtime) = mysql_fetch_row(pwg_query($query));

    list($curyear, $curmonth, $curday) = explode('-', $curdate);
    list($curhour) = explode(':', $curtime);

    $dirname =sprintf(FSTATS_FMT_RAW_DIR, $curyear, $curmonth, $curday, $curhour);
    fstats_Rmkdir($dirname);

    $filename = $dirname.'/'.sprintf(FSTATS_FMT_RAW_FILE, $curyear, $curmonth, $curday, $curhour, $user['id']);

    $contents = array();
    $contents['version'] = '1';

    $contents['date']         = $curdate;
    $contents['time']         = $curtime;
    $contents['year']         = $curyear;
    $contents['month']        = $curmonth;
    $contents['day']          = $curday;
    $contents['hour']         = $curhour;
    $contents['user_id']      = $user['id'];
    $contents['IP']           = $_SERVER['REMOTE_ADDR'];
    $contents['section']      = (isset($page['section']) ? "'".$page['section']."'" : 'NULL');
    $contents['category_id']  = (isset($page['category']) ? $page['category']['id'] : 'NULL');
    $contents['image_id']     = (isset($image_id) ? $image_id : 'NULL');
    $contents['image_type']   = (isset($image_type) ? "'".$image_type."'" : 'NULL');
    $contents['tag_ids']      = (isset($tags_string) ? "'".$tags_string."'" : 'NULL');

    $hfile = fopen($filename, 'a+');
    if ($hfile !== FALSE)
    {
      fwrite($hfile, serialize ($contents)."\n");
      fclose($hfile);
    }

  }

  // Stop Database statitics
  $do_log = false;

  return $do_log;
}


?>
